/**
 * View that shows the preview of the post data inside list 
 * (e.g.: in the fan page (=home page))
 * 
 * @author Matanya
 */
var ShortPostView = Backbone.View.extend(
{	
	tagName: 'li',

	events:
	{
		//'tap .video_img_container': 'videoClicked',		
		"tap": "itemClicked"
	},
	
	initialize: function () 
	{
		$(this.el).attr('data-role', 'button');		
		this.model.bind('change:commentsCount', this.renderCommentsCount, this);
	},
	
	render: function() 
	{	
		var timeAgo = Utils.TimeDate.timeAsText(this.model.get('createdTime') / 1000);

		var type = this.model.get('type');
		var picture = this.model.get('picture');
		var pictureHtml = ""; 
		if (picture)
		{
			if (type === "video") 
			{
				/*pictureHtml ='<div class="video_img_container">' + 
								'<span class="play_icon video_click"></span>' +
								'<img class="post_list_img video_img video_click" src="' + picture + '"></img>' +
							 '</div>';*/
				
				
				var videoUrl = this.model.get('videoUrl');
				//videoUrl = 'http://www.youtube.com/embed/JW5meKfy3fY';
						
				pictureHtml =  
				/*'<object style="width: 100%; height: 100%">' +
					'<param id="movie" value="' + videoUrl + '">' +
					'<param id="allowFullScreen" value="true">' +
					'<param id="allowScriptAccess" value="always">' +
					'<embed id="movie_embed" src="' + videoUrl + '" type="application/x-shockwave-flash" allowfullscreen="true" wmode="opaque" allowScriptAccess="always" width="100%" height="100%">' +
				'</object>';*/
				
				'<div class="video_img_container" style="position: relative; width: 200px; height: 200px">' +
				'<div style="position:absolute;top:0;left:0;width:100%;height:100%;">' +
				'<object style="width: 100%; height: 100%">' +
					'<embed class="movie_embed" src="' + videoUrl + '" type="application/x-shockwave-flash" allowfullscreen="true" wmode="opaque" allowScriptAccess="always" autoplay="0" width="100%" height="100%">' +
					//'<img class="post_list_img video_img video_click" src="' + picture + '"></img>' +
				'</object>' +


//				'<iframe class=”youtube-player” type=”text/html” width=”640″ height=”385″ src=”' + videoUrl + '” frameborder=”0″>' +
//				'</iframe>' +
				
				 
/*				'<object style="width: 100%; height: 100%">' +
//				'<object style="width: 300px; height: 300px">' +
					'<param id="movie" value="' + videoUrl + '">' +
					'<param id="allowFullScreen" value="true">' +
					'<param id="allowScriptAccess" value="always">' +
					'<embed id="movie_embed" src="' + videoUrl + '" type="application/x-shockwave-flash" allowfullscreen="true" wmode="opaque" allowScriptAccess="always" width="100%" height="100%">' +
//					'<embed id="movie_embed" src="' + videoUrl + '" type="application/x-shockwave-flash" allowfullscreen="true" wmode="opaque" allowScriptAccess="always" autoplay="0" controls="0" width="250px" height="100px">' +
//					'<embed id="movie_embed" src="' + videoUrl + '" type="application/x-shockwave-flash" allowfullscreen="true" wmode="opaque" allowScriptAccess="always" autoplay="0">' +
				'</object>' +*/
				'</div>'+
				'</div>';


			}
			else	
			{
				pictureHtml = '<img class="post_list_img photo_img" src="' + picture + '"></img>';
			}
		}

		// TODO: change to templates:
		var html =  
				'<img class="post_from_img" src="' + this.model.get('fromPicture') +'"></img>' + 
				'<div class="post_data_container">' +
				 	'<div class="post_from_name title_color">' + this.model.get('fromName') + '</div>' + 
					'<p class="post_list_message text_color">' +
						Utils.String.trailString(this.model.get('message'), 300) +
					'</p>' +
					pictureHtml + 
//					'</br>' +
					'<div class="post_list_extra_info text2_color ">' +
						'<span class="comments_count"></span>' +			
						'<span class="facebook_icon"></span>' +			
						'<span class="time_ago">' + timeAgo + '</span>' +			
					'</div>' +	
				'</div>' +
				'<div class="slide_arrow_image"></div>';

		$(this.el).addClass('post_list_item item_padding').html(html);


	/*	var aaa = $(this.el).find('.video_img_container');
		setTimeout(function()
		{
		//	alert('TO!');
			aaa.addClass('t3d');
		}, 10000);*/


		// Update the scroller after loading image:
		var $picture = $(this.el).find('.post_list_img');
		$picture.load(function()
		{
			Scrolling.onContentChanged();
		});

		// Render the "comments count" element:
		this.$commentsCount = $(this.el).find('.comments_count');
		this.renderCommentsCount();

		return this;
	},

	renderCommentsCount: function()
	{
		this.$commentsCount.html(localization.formatNumber(this.model.get('commentsCount')) +
								' comments');
	},
	
	itemClicked: function (event) 
	{
        var $eventTarget = $(event.target);
		if ($eventTarget.hasClass('video_click')) 
		{
			this.model.setSelectedVideo(true);
		}
		else 
		{
			this.model.setSelected(true);
		}
	},

	videoClicked: function (event) 
	{
		this.model.setSelectedVideo(true);
		event.preventDefault();
		return false;
	}	
		
});